#include "Nextion.h"

// https://www.reddit.com/r/arduino/comments/4b6jfi/nexconfigh_for_nextion_display_on_arduino_uno/
#define ESP32
HardwareSerial HMISerial(2); // pin 16=RX, pin 17=TX

String szNum;
char cBuffer[10]={0};

NexButton b0 = NexButton(0, 1, "b0");
NexButton b1 = NexButton(0, 2, "b1");
NexButton b2 = NexButton(0, 3, "b2");
NexButton b3 = NexButton(0, 4, "b3");
NexButton b4 = NexButton(0, 5, "b4");
NexButton b5 = NexButton(0, 6, "b5");
NexButton b6 = NexButton(0, 7, "b6");
NexButton b7 = NexButton(0, 8, "b7");
NexButton b8 = NexButton(0, 9, "b8");
NexButton b9 = NexButton(0, 10, "b9");
NexButton b10 = NexButton(0, 12, "b10");
NexButton b11 = NexButton(0, 13, "b11");

NexText t0 = NexText(0, 11, "t0");

NexTouch *nex_listen_list[] =
{
  &b0,
  &b1,
  &b2,
  &b3,
  &b4,
  &b5,
  &b6,
  &b7,
  &b8,
  &b9,
  NULL
};

void vGestionaCadena(String s) {
  szNum += s;

  if(szNum.length() > 4)
    szNum = "";
  szNum.toCharArray(cBuffer, szNum.length() + 1);
  t0.setText (cBuffer);
}

void b0Callback(void *ptr) {
  dbSerialPrintln("b0Callback");
  vGestionaCadena("1");
  //t0.setText("1");
}

void b1Callback(void *ptr) {
  dbSerialPrintln("b1Callback");
  vGestionaCadena("2");
  //t0.setText("2");
}

void b2Callback(void *ptr) {
  dbSerialPrintln("b2Callback");
  vGestionaCadena("3");
  //t0.setText("3");
}

void b3Callback(void *ptr) {
  dbSerialPrintln("b3Callback");
  vGestionaCadena("4");
  //t0.setText("4");
}

void b4Callback(void *ptr) {
  dbSerialPrintln("b4Callback");
  vGestionaCadena("5");
  //t0.setText("5");
}

void b5Callback(void *ptr) {
  dbSerialPrintln("b5Callback");
  vGestionaCadena("6");
  //t0.setText("6");
}

void b6Callback(void *ptr) {
  dbSerialPrintln("b6Callback");
  vGestionaCadena("7");
  //t0.setText("7");
}

void b7Callback(void *ptr) {
  dbSerialPrintln("b7Callback");
  vGestionaCadena("8");
  //t0.setText("8");
}

void b8Callback(void *ptr) {
  dbSerialPrintln("b9Callback");
  vGestionaCadena("9");
  //t0.setText("9");
}

void b9Callback(void *ptr) {
  dbSerialPrintln("b9Callback");
  vGestionaCadena("0");
  //t0.setText("0");
}

void setup() {
  //Serial.begin(115200);
  szNum = "";
  nexInit();
  b0.attachPop(b0Callback, &b0);
  b1.attachPop(b1Callback, &b1);
  b2.attachPop(b2Callback, &b2);
  b3.attachPop(b3Callback, &b3);
  b4.attachPop(b4Callback, &b4);
  b5.attachPop(b5Callback, &b5);
  b6.attachPop(b6Callback, &b6);
  b7.attachPop(b7Callback, &b7);
  b8.attachPop(b8Callback, &b8);
  b9.attachPop(b9Callback, &b9);

  dbSerialPrintln("setup done");
  //Serial.println("setup fet");
}

void loop() {
  nexLoop(nex_listen_list);
}
